#pragma once

namespace Passer {
namespace RoboidControl {

class Encoder {
 public:
  Encoder();
  Encoder(unsigned char transitionsPerRotation);

  virtual int GetPulseCount();
  virtual float GetPulsesPerSecond(float currentTimeMs);

  virtual float GetDistance();
  virtual float GetRevolutionsPerSecond(float currentTimeMs);

 protected:
  unsigned char transitionsPerRotation;
};

}  // namespace RoboidControl
}  // namespace Passer
using namespace Passer::RoboidControl;